/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
	"strings"
)


// OrganizationApiService OrganizationApi service
type OrganizationApiService service

type ApiOrgAllRequest struct {
	ctx context.Context
	ApiService *OrganizationApiService
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	page *int32
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiOrgAllRequest) CVEAPIORG(cVEAPIORG string) ApiOrgAllRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiOrgAllRequest) CVEAPIUSER(cVEAPIUSER string) ApiOrgAllRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiOrgAllRequest) CVEAPIKEY(cVEAPIKEY string) ApiOrgAllRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

// The current page in the paginator
func (r ApiOrgAllRequest) Page(page int32) ApiOrgAllRequest {
	r.page = &page
	return r
}

func (r ApiOrgAllRequest) Execute() (*ListOrgsResponse, *http.Response, error) {
	return r.ApiService.OrgAllExecute(r)
}

/*
OrgAll Retrieves all organizations (accessible to Secretariat)

  <h2>Access Control</h2>  <p>User must belong to an organization with the <b>Secretariat</b> role</p>  <h2>Expected Behavior</h2>  <p><b>Secretariat:</b> Retrieves information about all organizations</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiOrgAllRequest
*/
func (a *OrganizationApiService) OrgAll(ctx context.Context) ApiOrgAllRequest {
	return ApiOrgAllRequest{
		ApiService: a,
		ctx: ctx,
	}
}

// Execute executes the request
//  @return ListOrgsResponse
func (a *OrganizationApiService) OrgAllExecute(r ApiOrgAllRequest) (*ListOrgsResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *ListOrgsResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "OrganizationApiService.OrgAll")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/org"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}

	if r.page != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "page", r.page, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiOrgCreateSingleRequest struct {
	ctx context.Context
	ApiService *OrganizationApiService
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	createOrgRequest *CreateOrgRequest
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiOrgCreateSingleRequest) CVEAPIORG(cVEAPIORG string) ApiOrgCreateSingleRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiOrgCreateSingleRequest) CVEAPIUSER(cVEAPIUSER string) ApiOrgCreateSingleRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiOrgCreateSingleRequest) CVEAPIKEY(cVEAPIKEY string) ApiOrgCreateSingleRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

func (r ApiOrgCreateSingleRequest) CreateOrgRequest(createOrgRequest CreateOrgRequest) ApiOrgCreateSingleRequest {
	r.createOrgRequest = &createOrgRequest
	return r
}

func (r ApiOrgCreateSingleRequest) Execute() (*CreateOrgResponse, *http.Response, error) {
	return r.ApiService.OrgCreateSingleExecute(r)
}

/*
OrgCreateSingle Creates an organization as specified in the request body (accessible to Secretariat)

  <h2>Access Control</h2>  <p>User must belong to an organization with the <b>Secretariat</b> role</p>  <h2>Expected Behavior</h2>  <p><b>Secretariat:</b> Creates an organization</p>  

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiOrgCreateSingleRequest
*/
func (a *OrganizationApiService) OrgCreateSingle(ctx context.Context) ApiOrgCreateSingleRequest {
	return ApiOrgCreateSingleRequest{
		ApiService: a,
		ctx: ctx,
	}
}

// Execute executes the request
//  @return CreateOrgResponse
func (a *OrganizationApiService) OrgCreateSingleExecute(r ApiOrgCreateSingleRequest) (*CreateOrgResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CreateOrgResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "OrganizationApiService.OrgCreateSingle")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/org"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}
	if r.createOrgRequest == nil {
		return localVarReturnValue, nil, reportError("createOrgRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	// body params
	localVarPostBody = r.createOrgRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiOrgIdQuotaRequest struct {
	ctx context.Context
	ApiService *OrganizationApiService
	shortname string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiOrgIdQuotaRequest) CVEAPIORG(cVEAPIORG string) ApiOrgIdQuotaRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiOrgIdQuotaRequest) CVEAPIUSER(cVEAPIUSER string) ApiOrgIdQuotaRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiOrgIdQuotaRequest) CVEAPIKEY(cVEAPIKEY string) ApiOrgIdQuotaRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

func (r ApiOrgIdQuotaRequest) Execute() (*GetOrgQuotaResponse, *http.Response, error) {
	return r.ApiService.OrgIdQuotaExecute(r)
}

/*
OrgIdQuota Retrieves an organization's CVE ID quota (accessible to all registered users)

  <h2>Access Control</h2>  <p>All registered users can access this endpoint</p>  <h2>Expected Behavior</h2>  <p><b>Regular, CNA & Admin Users:</b> Retrieves the CVE ID quota for the user's organization</p>  <p><b>Secretariat:</b> Retrieves the CVE ID quota for any organization</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param shortname The shortname of the organization
 @return ApiOrgIdQuotaRequest
*/
func (a *OrganizationApiService) OrgIdQuota(ctx context.Context, shortname string) ApiOrgIdQuotaRequest {
	return ApiOrgIdQuotaRequest{
		ApiService: a,
		ctx: ctx,
		shortname: shortname,
	}
}

// Execute executes the request
//  @return GetOrgQuotaResponse
func (a *OrganizationApiService) OrgIdQuotaExecute(r ApiOrgIdQuotaRequest) (*GetOrgQuotaResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *GetOrgQuotaResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "OrganizationApiService.OrgIdQuota")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/org/{shortname}/id_quota"
	localVarPath = strings.Replace(localVarPath, "{"+"shortname"+"}", url.PathEscape(parameterValueToString(r.shortname, "shortname")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiOrgSingleRequest struct {
	ctx context.Context
	ApiService *OrganizationApiService
	identifier string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiOrgSingleRequest) CVEAPIORG(cVEAPIORG string) ApiOrgSingleRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiOrgSingleRequest) CVEAPIUSER(cVEAPIUSER string) ApiOrgSingleRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiOrgSingleRequest) CVEAPIKEY(cVEAPIKEY string) ApiOrgSingleRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

func (r ApiOrgSingleRequest) Execute() (*GetOrgResponse, *http.Response, error) {
	return r.ApiService.OrgSingleExecute(r)
}

/*
OrgSingle Retrieves information about the organization specified by short name or UUID (accessible to all registered users)

  <h2>Access Control</h2>  <p>All registered users can access this endpoint</p>  <h2>Expected Behavior</h2>  <p><b>Regular, CNA & Admin Users:</b> Retrieves organization record for the specified shortname or UUID if it is the user's organization</p>  <p><b>Secretariat:</b> Retrieves information about any organization</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param identifier The shortname or UUID of the organization
 @return ApiOrgSingleRequest
*/
func (a *OrganizationApiService) OrgSingle(ctx context.Context, identifier string) ApiOrgSingleRequest {
	return ApiOrgSingleRequest{
		ApiService: a,
		ctx: ctx,
		identifier: identifier,
	}
}

// Execute executes the request
//  @return GetOrgResponse
func (a *OrganizationApiService) OrgSingleExecute(r ApiOrgSingleRequest) (*GetOrgResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *GetOrgResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "OrganizationApiService.OrgSingle")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/org/{identifier}"
	localVarPath = strings.Replace(localVarPath, "{"+"identifier"+"}", url.PathEscape(parameterValueToString(r.identifier, "identifier")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiOrgUpdateSingleRequest struct {
	ctx context.Context
	ApiService *OrganizationApiService
	shortname string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	idQuota *int32
	name *string
	newShortName *string
	activeRolesAdd *string
	activeRolesRemove *string
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiOrgUpdateSingleRequest) CVEAPIORG(cVEAPIORG string) ApiOrgUpdateSingleRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiOrgUpdateSingleRequest) CVEAPIUSER(cVEAPIUSER string) ApiOrgUpdateSingleRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiOrgUpdateSingleRequest) CVEAPIKEY(cVEAPIKEY string) ApiOrgUpdateSingleRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

// The new number of CVE IDs the organization is allowed to have in the RESERVED state at one time
func (r ApiOrgUpdateSingleRequest) IdQuota(idQuota int32) ApiOrgUpdateSingleRequest {
	r.idQuota = &idQuota
	return r
}

// The new name for the organization
func (r ApiOrgUpdateSingleRequest) Name(name string) ApiOrgUpdateSingleRequest {
	r.name = &name
	return r
}

// The new shortname for the organization
func (r ApiOrgUpdateSingleRequest) NewShortName(newShortName string) ApiOrgUpdateSingleRequest {
	r.newShortName = &newShortName
	return r
}

// Add an active role to the organization
func (r ApiOrgUpdateSingleRequest) ActiveRolesAdd(activeRolesAdd string) ApiOrgUpdateSingleRequest {
	r.activeRolesAdd = &activeRolesAdd
	return r
}

// Remove an active role from the organization
func (r ApiOrgUpdateSingleRequest) ActiveRolesRemove(activeRolesRemove string) ApiOrgUpdateSingleRequest {
	r.activeRolesRemove = &activeRolesRemove
	return r
}

func (r ApiOrgUpdateSingleRequest) Execute() (*UpdateOrgResponse, *http.Response, error) {
	return r.ApiService.OrgUpdateSingleExecute(r)
}

/*
OrgUpdateSingle Updates information about the organization specified by short name (accessible to Secretariat)

  <h2>Access Control</h2>  <p>User must belong to an organization with the <b>Secretariat</b> role</p>  <h2>Expected Behavior</h2>  <p><b>Secretariat:</b> Updates any organization's information</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param shortname The shortname of the organization
 @return ApiOrgUpdateSingleRequest
*/
func (a *OrganizationApiService) OrgUpdateSingle(ctx context.Context, shortname string) ApiOrgUpdateSingleRequest {
	return ApiOrgUpdateSingleRequest{
		ApiService: a,
		ctx: ctx,
		shortname: shortname,
	}
}

// Execute executes the request
//  @return UpdateOrgResponse
func (a *OrganizationApiService) OrgUpdateSingleExecute(r ApiOrgUpdateSingleRequest) (*UpdateOrgResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPut
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *UpdateOrgResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "OrganizationApiService.OrgUpdateSingle")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/org/{shortname}"
	localVarPath = strings.Replace(localVarPath, "{"+"shortname"+"}", url.PathEscape(parameterValueToString(r.shortname, "shortname")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}

	if r.idQuota != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "id_quota", r.idQuota, "")
	}
	if r.name != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "name", r.name, "")
	}
	if r.newShortName != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "new_short_name", r.newShortName, "")
	}
	if r.activeRolesAdd != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "active_roles.add", r.activeRolesAdd, "")
	}
	if r.activeRolesRemove != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "active_roles.remove", r.activeRolesRemove, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
